'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _empty = require('rxjs/observable/empty');

var _map = require('rxjs/operator/map');

var _filter = require('rxjs/operator/filter');

var _reduxSubspace = require('redux-subspace');

/**
 * Copyright 2017, IOOF Holdings Limited.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

var identity = function identity(x) {
    return x;
};

var subspaced = function subspaced(mapState, namespace) {
    var subspaceDecorator = (0, _reduxSubspace.subspace)(mapState, namespace);
    return function (epic) {
        return function (action$, store, dependencies) {
            var _context;

            var subspacedStore = subspaceDecorator(store);

            var filteredAction$ = (_context = _map.map.call(action$, function (action) {
                return subspacedStore.processAction(action, identity);
            }), _filter.filter).call(_context, identity);

            epic(filteredAction$, subspacedStore, dependencies).subscribe(subspacedStore.dispatch);
            return (0, _empty.empty)();
        };
    };
};

exports.default = subspaced;